/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Supplement to Hash Table management module version 1.3.

    Copyright (C) 2002 by Sundaresh Venugopal

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You may contact the author via email at one of the following address
    sundaresh@mail.com , or  cbuff@programmer.net .

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#ifndef HASH_FN_H
#define HASH_FN_H

unsigned long strsign(char *string);
unsigned long _strsign(char *string);

int hashes;

#define HOCCU (.90)
int hashstep;
#define hashstep0(key,size) (1 + ((key) % ((size) - 1)))
#define hashstep1(size) ((size) << 1)
int hash0(unsigned long key,int size);
int hash1(unsigned long key,int size);
int hash2(unsigned long key,int size);
int hash3(unsigned long key,int size);
int hash4(unsigned long key,int size);
int hash5(unsigned long key,int size);

#define _HOCCU (.90)
int _hashstep;
int _hashstep0(int size);
int _hash0(unsigned long key,int size);

int mdhash(unsigned long key,int size);
int _rndhash(unsigned long key,int size);

int id_hash(unsigned long key,int size);
int kd_hash(unsigned long key,int shift,int count);
int keydiv = 7,keymul = 3;
int kr_hash(unsigned long key);
unsigned short _hashl2s(unsigned long key);

unsigned _hash(unsigned *key,int len,long double hashratio);
unsigned _vhash(unsigned *key,int len,long double *hashratio);
long double dhashratio(int len);

int asc_ctrn(int letter);
int asc_citrn(int letter);

/* These macros must be re-defined for NON-ASCII character sets */
#define ctrn(letter) asc_ctrn(letter)
#define citrn(letter) asc_citrn(letter)

unsigned *packkey(unsigned *key,int len,char *string,int case);

#endif
